function [a s tau] = hilfactor(f)
%[a s tau] = hilfactor(f)
%
%hilfactor factorizes a function based on the hilbert transform.
%
%   INVERSE: s = cos(tau);
%            f = a.*s;

F = hilbert(f);
a = abs(F);
tau = unwrap(angle(F));
s = cos(tau);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%